<div class="workflow-right-header workflow-header">Publish to Marketplace</div>
<div class="container" *ngIf="data$ | async as data">
  <!-- status stepper start-->
  <div class="stepper">
    <div class="flex-column">
      <span
        [ngClass]="
          statusStepperProgress.documentation
            ? 'image-content-active model-documentation-active'
            : 'image-content-inactive model-documentation'
        "
        class="image-content"
      ></span>
      <span>Model documentation</span>
    </div>
    <span
      [ngClass]="
        statusStepperProgress.requestApproval
          ? 'loading-active'
          : 'loading-inactive'
      "
    ></span>
    <div class="request-approval-container">
      <span
        [ngClass]="
          statusStepperProgress.requestApproval
            ? 'request-approval-active request-approval-stepper-active'
            : 'image-content-inactive request-approval'
        "
        class="image-content"
      ></span>
      <span>Request Approval</span>
      <button
        *ngIf="statusStepperProgress.requestApproval"
        class="withdraw-request-button"
        mat-raised-button
        (click)="onClickWithdrawRequest()"
      >
        Withdraw request
      </button>
    </div>
    <span
      [ngClass]="
        statusStepperProgress.published ? 'loading-active' : 'loading-inactive'
      "
      class="loading-inactive"
    ></span>
    <div class="flex-column">
      <span
        [ngClass]="
          statusStepperProgress.published
            ? 'loading-active'
            : 'yet-not-publish image-content-inactive'
        "
        class="image-content"
      ></span>
      <span>Published</span>
    </div>
  </div>
  <!-- status stepper end-->

  <!-- Steps to submit publication start-->
  <form [formGroup]="publishToMarketPlaceForm" (ngSubmit)="submit()">
    <div class="flex-column">
      <span class="form-field-label">Model catalog</span>
      <mat-form-field>
        <mat-label>Select a catalog</mat-label>
        <mat-select
          formControlName="catalog"
          (selectionChange)="onChangeCatalog($event)"
        >
          @for (catalog of catalogs; track catalog) {
            <mat-option [value]="catalog">{{ catalog.name }}</mat-option>
          }
        </mat-select>
      </mat-form-field>
    </div>

    <div class="form-container">
      <div class="form-header">
        <span class="form-title">STEPS TO SUBMIT PUBLICATION</span>
        <span class="timeline">( COMPLETED)</span>
      </div>
      @if (publishToMarketPlaceForm.controls["catalog"].value) {
        <!--Model name starts-->
        <div class="flex-column">
          <div class="step-container">
            <div class="timeline-container">
              @if (publishToMarketPlaceForm.value.name) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>1</span>
                </div>
              }
              <mat-divider
                vertical
                class="divider-color full-height"
              ></mat-divider>
            </div>
            <div class="flex-column flex-grow">
              <div class="flex-row">
                <span class="form-field-label">Model name</span>
                <button class="custom-icon" (click)="onClickEditModelName()">
                  <mat-icon>edit</mat-icon>
                </button>
              </div>

              <div class="flex-row">
                <mat-form-field>
                  <mat-label>Model name</mat-label>
                  <input matInput formControlName="name" />
                </mat-form-field>
              </div>
              <mat-divider
                class="divider-color horizontal-divider"
              ></mat-divider>
            </div>
          </div>
          <!--Model name ends-->

          <!--Model description starts-->
          <div class="step-container">
            <div class="timeline-container">
              @if (publishToMarketPlaceForm.value.description) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>2</span>
                </div>
              }

              <mat-divider
                vertical
                class="divider-color full-height"
              ></mat-divider>
            </div>
            <div class="flex-column flex-grow">
              <div class="flex-row">
                <span class="form-field-label">Model description</span>
                <button class="custom-icon" (click)="addEditDescription()">
                  @if (publishToMarketPlaceForm.value.description) {
                    <mat-icon>edit</mat-icon>
                  } @else {
                    <mat-icon>add</mat-icon>
                  }
                </button>
              </div>
              <div
                *ngIf="publishToMarketPlaceForm.value.description"
                [innerHTML]="publishToMarketPlaceForm.value.description"
              ></div>
              <div class="flex-column">
                <span class="description-hint"
                  >The provided description less than 500 characters
                </span>
                <span class="text-medium"
                  >If you want to improve your model description rating then
                  please add more details</span
                >
              </div>
              <mat-divider
                class="divider-color horizontal-divider"
              ></mat-divider>
            </div>
          </div>
          <!--Model description ends-->

          <!--Model category starts-->
          <div class="step-container">
            <div class="timeline-container">
              @if (
                publishToMarketPlaceForm.value.category &&
                publishToMarketPlaceForm.value.toolkitType
              ) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>3</span>
                </div>
              }

              <mat-divider
                vertical
                class="divider-color full-height"
              ></mat-divider>
            </div>
            <div class="flex-column flex-grow">
              <div class="flex-column">
                <span class="form-field-label">Model category</span>
                <mat-form-field class="full-width">
                  <mat-label>Select category</mat-label>
                  <mat-select
                    formControlName="category"
                    [compareWith]="compareObjects"
                  >
                    @for (category of categories; track category) {
                      <mat-option [value]="category">{{
                        category.name
                      }}</mat-option>
                    }
                  </mat-select>
                </mat-form-field>
              </div>
              <mat-form-field class="full-width">
                <mat-label>Select toolkitType</mat-label>
                <mat-select
                  formControlName="toolkitType"
                  [compareWith]="compareObjects"
                >
                  @for (toolkitType of toolkitTypes; track toolkitType) {
                    <mat-option [value]="toolkitType">{{
                      toolkitType.name
                    }}</mat-option>
                  }
                </mat-select>
              </mat-form-field>
              <mat-divider
                class="divider-color horizontal-divider"
              ></mat-divider>
            </div>
          </div>
          <!--Model category ends-->

          <!--license profile start-->
          <div class="step-container">
            <div class="timeline-container">
              @if (data.licenseProfile) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>4</span>
                </div>
              }

              <mat-divider
                vertical
                class="divider-color full-height"
              ></mat-divider>
            </div>
            <div class="flex-column flex-grow">
              <div class="license-container">
                <div class="flex-row">
                  <span class="form-field-label">Model license profile</span>
                  <button class="custom-icon" (click)="onLicenseProfileClick()">
                    @if (data.licenseProfile) {
                      <mat-icon>edit</mat-icon>
                    } @else {
                      <mat-icon>add</mat-icon>
                    }
                  </button>
                </div>
                <input
                  style="width: 20%"
                  *ngIf="licenseName"
                  [value]="licenseName"
                  disabled
                />
              </div>
              @if (addEditLicenseProfile) {
                <div class="flex-row full-width spacebetween buttons-layout">
                  <button
                    mat-stroked-button
                    color="primary"
                    (click)="onClickUploadLicenseProfile()"
                  >
                    Upload
                  </button>
                  <button
                    *ngIf="data.licenseProfile"
                    mat-stroked-button
                    color="primary"
                    (click)="onClickUpdateLicenseProfile()"
                  >
                    Update
                  </button>
                  <button
                    *ngIf="!data.licenseProfile"
                    mat-stroked-button
                    color="primary"
                    (click)="onClickCreateLicenseProfile()"
                  >
                    Create
                  </button>
                </div>
              }
              <mat-divider
                class="divider-color horizontal-divider"
              ></mat-divider>
            </div>
          </div>
          <!--license profile end-->

          <!--upload documents start-->
          <div class="step-container">
            <div class="timeline-container">
              @if (documents().length > 0) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>5</span>
                </div>
              }

              <mat-divider
                vertical
                class="divider-color full-height"
              ></mat-divider>
            </div>
            <div class="upload-file-container flex-grow">
              <div class="flex-row">
                <span class="form-field-label">Model Documents </span>

                <button
                  class="custom-icon"
                  (click)="onClickUploadDocumentFile()"
                >
                  @if (documents().length > 0) {
                    <mat-icon>edit</mat-icon>
                  } @else {
                    <mat-icon>add</mat-icon>
                  }
                </button>
              </div>

              <mat-form-field>
                <mat-chip-grid #documentsGrid formControlName="documents">
                  @for (document of documents(); track document) {
                    <mat-chip-row (removed)="removeDocument(document)">
                      {{ document.name }}
                      <button
                        matChipRemove
                        [attr.aria-label]="'remove ' + document"
                      >
                        <mat-icon>cancel</mat-icon>
                      </button>
                    </mat-chip-row>
                  }
                </mat-chip-grid>
                <input
                  matInput
                  [matChipInputFor]="documentsGrid"
                  (matChipInputTokenEnd)="onAddEditDocuments($event)"
                />
              </mat-form-field>
              <div class="flex-column flex-grow">
                <span class="text-medium"
                  >Add documents (such as a README file) to give more details
                  and show how to use your model.</span
                >
              </div>
              <mat-divider
                class="divider-color horizontal-divider"
              ></mat-divider>
            </div>
          </div>
          <!--upload documents end-->

          <!--tags starts-->
          <div class="step-container">
            <div class="timeline-container">
              @if (publishToMarketPlaceForm.value.tags.length > 0) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>7</span>
                </div>
              }
              <mat-divider
                vertical
                class="divider-color full-height"
              ></mat-divider>
            </div>
            <div class="flex-column flex-grow">
              <span class="form-field-label">Model tags</span>
              <mat-form-field class="flex-grow">
                <mat-label>Add tag</mat-label>
                <mat-chip-grid #chipGrid>
                  @for (tag of tagsItems(); track tag) {
                    <mat-chip-row (removed)="removeTag(tag)">
                      {{ tag.tag }}
                      <button matChipRemove [attr.aria-label]="'remove ' + tag">
                        <mat-icon>cancel</mat-icon>
                      </button>
                    </mat-chip-row>
                  }
                </mat-chip-grid>
                <input
                  #tagInput
                  [formControl]="tagCtrl"
                  [matChipInputFor]="chipGrid"
                  [matAutocomplete]="auto"
                  [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
                  (matChipInputTokenEnd)="addTag($event)"
                  (input)="onChangeInput($event)"
                />
                <mat-autocomplete
                  #auto="matAutocomplete"
                  (optionSelected)="selected($event)"
                >
                  @for (tag of filteredTags | async; track tag) {
                    <mat-option [value]="tag"
                      ><span class="autocomplete-option">{{
                        tag
                      }}</span></mat-option
                    >
                  }
                </mat-autocomplete>
              </mat-form-field>
              <mat-divider
                class="divider-color horizontal-divider"
              ></mat-divider>
            </div>
          </div>
          <!--tags ends-->

          <!--upload image start-->
          <div class="step-container">
            <div class="timeline-container">
              @if (imageToShow) {
                <span class="completed-step"></span>
              } @else {
                <div class="timeline-entry">
                  <span>8</span>
                </div>
              }
            </div>
            <div class="flex-column">
              <div class="flex-row">
                <span class="form-field-label">Model image </span>

                @if (!imageToShow) {
                  <button
                    class="custom-icon"
                    (click)="onClickUploadImageFile()"
                  >
                    <mat-icon>upload</mat-icon>
                  </button>
                }
              </div>
              <p class="upload-text-hint">
                Upload an image that will identify your model in Marketplace.
                You can upload jpg, jpeg, png and gif file with maximum size of
                1MB.
              </p>

              <div *ngIf="imageToShow" class="single-file">
                <div class="image-container">
                  <img class="file-image" [src]="imageToShow" alt="file" />
                </div>
                <div class="flex-row file-name">
                  <span *ngIf="imageToShow.name"> {{ imageToShow?.name }}</span>
                  <span>|</span>
                  <a (click)="onClickUploadImageFile()">Change</a>
                </div>
              </div>
            </div>
          </div>
          <!--upload image end-->
        </div>
      }

      <div class="buttons-container">
        <button
          (click)="unpublishModel()"
          mat-raised-button
          color="primary"
          [disabled]="publishToMarketPlaceForm.invalid"
        >
          Unpublish model
        </button>
        <button
          mat-raised-button
          color="primary"
          type="submit"
          [disabled]="!enableSubmit"
        >
          Publish model
        </button>
      </div>
    </div>
  </form>
  <!-- Steps to submit publication end-->
</div>
